; ./vmt/./conc/lamport_safe_000.smt2
(set-logic HORN)

(declare-fun |state| ( Bool Bool Bool Bool Bool Bool Bool Bool Bool Bool Int Int Int Int Int ) Bool)

(assert
  (forall ( (A Bool) (B Bool) (C Int) (D Bool) (E Int) (F Int) (G Int) (H Bool) (I Bool) (J Bool) (K Bool) (L Bool) (M Int) (N Bool) (O Bool) ) 
    (=>
      (and
        (and (= C 0)
     (= M 0)
     (= G 0)
     (= E 0)
     (or H I J (not K) (not L))
     (or D N O (not A) (not B))
     (or (not L) (and (not H) (not I) (not J)))
     (or (not B) (and (not D) (not N) (not O)))
     (not O)
     (not N)
     (not L)
     (not K)
     (not J)
     (not I)
     (not H)
     (not A)
     (not B)
     (not D)
     (= F 0))
      )
      (state J I H L K D O N B A F E C M G)
    )
  )
)
(assert
  (forall ( (A Bool) (B Bool) (C Int) (D Bool) (E Int) (F Int) (G Bool) (H Bool) (I Int) (J Int) (K Int) (L Int) (M Bool) (N Bool) (O Bool) (P Bool) (Q Bool) (R Bool) (S Bool) (T Bool) (U Bool) (V Int) (W Bool) (X Int) (Y Bool) (Z Bool) (A1 Bool) (B1 Bool) (C1 Bool) (D1 Int) (E1 Bool) (F1 Bool) ) 
    (=>
      (and
        (state A1 Z Y C1 B1 D F1 E1 B A F E C D1 X)
        (let ((a!1 (and (not Q)
                (not P)
                (not O)
                (not N)
                (not M)
                (= C L)
                (= E K)
                (= F I)
                (= X J)))
      (a!2 (and (or (not (= E 2)) (and P (not O) N M))
                (or (= E 2) (and P O N (not M)))
                (= C L)
                (= E K)
                (= F I)
                (= X J)))
      (a!3 (and (or (<= 1 D1) (and (not P) O N (not M)))
                (or (not (<= 1 D1)) (and P (not O) N (not M)))
                (= C L)
                (= E K)
                (= F I)
                (= X J)))
      (a!4 (and (or (not (= E 0)) (and (not P) O (not N) M))
                (or (= E 0) (and P O (not N) (not M)))
                (= C L)
                (= E K)
                (= F I)
                (= X J)))
      (a!5 (and (or (not (= E 0)) (and (not P) (not O) N M))
                (or (= E 0) (and P O N (not M)))
                (= C L)
                (= E K)
                (= F I)
                (= X J)))
      (a!6 (and (or (= F 2) (and (not P) (not O) N (not M)))
                (or (not (= F 2)) (and P (not O) N M))
                (= C L)
                (= E K)
                (= F I)
                (= X J)))
      (a!7 (and (or (= E 0) (and (not P) (not O) (not N) M))
                (or (not (= E 0)) (and P (not O) (not N) M))
                (= C L)
                (= E K)
                (= F I)
                (= X J)))
      (a!8 (and (not W)
                (not U)
                (not T)
                (not S)
                (not R)
                (= C L)
                (= E K)
                (= F I)
                (= D1 V)))
      (a!9 (and (or (not (= E 1)) (and U (not T) S R))
                (or (= E 1) (and U T S (not R)))
                (= C L)
                (= E K)
                (= F I)
                (= D1 V)))
      (a!10 (and (or (<= 1 X) (and (not U) T S (not R)))
                 (or (not (<= 1 X)) (and U (not T) S (not R)))
                 (= C L)
                 (= E K)
                 (= F I)
                 (= D1 V)))
      (a!11 (and (or (not (= E 0)) (and (not U) T (not S) R))
                 (or (= E 0) (and U T (not S) (not R)))
                 (= C L)
                 (= E K)
                 (= F I)
                 (= D1 V)))
      (a!12 (and (or (not (= E 0)) (and (not U) (not T) S R))
                 (or (= E 0) (and U T S (not R)))
                 (= C L)
                 (= E K)
                 (= F I)
                 (= D1 V)))
      (a!13 (and (or (= F 1) (and (not U) (not T) S (not R)))
                 (or (not (= F 1)) (and U (not T) S R))
                 (= C L)
                 (= E K)
                 (= F I)
                 (= D1 V)))
      (a!14 (and (or (= E 0) (and (not U) (not T) (not S) R))
                 (or (not (= E 0)) (and U (not T) (not S) R))
                 (= C L)
                 (= E K)
                 (= F I)
                 (= D1 V))))
  (and (or Y
           Z
           A1
           B1
           (not C1)
           (not G)
           (and Q
                (not P)
                (not O)
                (not N)
                (not M)
                (= C L)
                (= E K)
                (= F I)
                (= X J)))
       (or Y
           Z
           A1
           B1
           C1
           (not G)
           (and P (not O) (not N) (not M) (= C L) (= E K) (= F I) (= J 2)))
       (or A
           D
           E1
           F1
           (not B)
           (not H)
           (and W
                (not U)
                (not T)
                (not S)
                (not R)
                (= C L)
                (= E K)
                (= F I)
                (= D1 V)))
       (or A
           B
           D
           E1
           F1
           (not H)
           (and U (not T) (not S) (not R) (= C L) (= E K) (= F I) (= V 1)))
       (or Y Z (not A1) (not B1) (not G) a!1)
       (or Z B1 (not Y) (not A1) (not G) a!1)
       (or (not Y)
           (not Z)
           (not A1)
           (not B1)
           (not G)
           (and Q
                (not P)
                (not O)
                (not N)
                (not M)
                (= C L)
                (= E K)
                (= F I)
                (= J 0)))
       (or Z
           (not Y)
           (not A1)
           (not B1)
           (not G)
           (and (not P) O N M (= E K) (= F I) (= L 2) (= X J)))
       (or Y
           B1
           (not Z)
           (not A1)
           (not G)
           (and P O (not N) M (= C L) (= F I) (= K 2) (= X J)))
       (or Y
           (not Z)
           (not A1)
           (not B1)
           (not G)
           (and P O N M (= C L) (= F I) (= K 0) (= X J)))
       (or Z
           A1
           B1
           (not Y)
           (not G)
           (and (not P) O (not N) (not M) (= C L) (= E K) (= I 2) (= X J)))
       (or Y
           Z
           A1
           (not B1)
           (not G)
           (and P (not O) N (not M) (= C L) (= E K) (= F I) (= J 2)))
       (or A1
           B1
           (not Y)
           (not Z)
           (not G)
           (and (not P) (not O) (not N) M (= C L) (= E K) (= F I) (= J 0)))
       (or Y A1 (not Z) (not B1) (not G) a!2)
       (or Z A1 (not Y) (not B1) (not G) a!3)
       (or Y A1 B1 (not Z) (not G) a!4)
       (or A1 (not Y) (not Z) (not B1) (not G) a!5)
       (or B1 (not Y) (not Z) (not A1) (not G) a!6)
       (or Y Z B1 (not A1) (not G) a!7)
       (or A F1 (not E1) (not D) (not H) a!8)
       (or E1 F1 (not D) (not A) (not H) a!8)
       (or (not E1)
           (not F1)
           (not D)
           (not A)
           (not H)
           (and W
                (not U)
                (not T)
                (not S)
                (not R)
                (= C L)
                (= E K)
                (= F I)
                (= V 0)))
       (or F1
           (not E1)
           (not D)
           (not A)
           (not H)
           (and (not U) T S R (= E K) (= F I) (= L 1) (= D1 V)))
       (or A
           E1
           (not F1)
           (not D)
           (not H)
           (and U T (not S) R (= C L) (= F I) (= K 1) (= D1 V)))
       (or E1
           (not F1)
           (not D)
           (not A)
           (not H)
           (and U T S R (= C L) (= F I) (= K 0) (= D1 V)))
       (or A
           D
           F1
           (not E1)
           (not H)
           (and (not U) T (not S) (not R) (= C L) (= E K) (= I 1) (= D1 V)))
       (or D
           E1
           F1
           (not A)
           (not H)
           (and U (not T) S (not R) (= C L) (= E K) (= F I) (= V 1)))
       (or A
           D
           (not E1)
           (not F1)
           (not H)
           (and (not U) (not T) (not S) R (= C L) (= E K) (= F I) (= V 0)))
       (or D E1 (not F1) (not A) (not H) a!9)
       (or D F1 (not E1) (not A) (not H) a!10)
       (or A D E1 (not F1) (not H) a!11)
       (or D (not E1) (not F1) (not A) (not H) a!12)
       (or A (not E1) (not F1) (not D) (not H) a!13)
       (or A E1 F1 (not D) (not H) a!14)
       (or Y Z A1 (not B1) (not C1))
       (or P O M (not N) (not Q))
       (or U T R (not S) (not W))
       (or D E1 F1 (not A) (not B))
       (or (not C1) (and (not Y) (not Z) (not A1)))
       (or G (and (= X J) (= Y P) (= Z O) (= A1 M) (= B1 N) (= C1 Q)))
       (or H (and (= D1 V) (= A S) (= B W) (= D R) (= E1 U) (= F1 T)))
       (or (not Q) (and (not P) (not O) (not M)))
       (or (not W) (and (not U) (not T) (not R)))
       (or (not B) (and (not D) (not E1) (not F1)))
       (not (= G H))))
      )
      (state M O P Q N R T U W S I K L V J)
    )
  )
)
(assert
  (forall ( (A Bool) (B Bool) (C Int) (D Bool) (E Int) (F Int) (G Int) (H Bool) (I Bool) (J Bool) (K Bool) (L Bool) (M Int) (N Bool) (O Bool) ) 
    (=>
      (and
        (state J I H L K D O N B A F E C M G)
        (and (= O true) (not N) (= A true) (= D true) (not (= C 1)))
      )
      false
    )
  )
)

(check-sat)
(exit)
